=== debian/changelog ===
ros-melodic-cartographer (1.0.0-0bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- The Cartographer Authors <cartographer-owners@googlegroups.com>  Fri, 01 Jun 2018 12:10:48 -0000

ros-melodic-cartographer (0.3.0-0bionic) bionic; urgency=high

  https://github.com/googlecartographer/cartographer/compare/0.2.0...0.3.0

 -- The Cartographer Owners <cartographer-owners@googlegroups.com>  Wed, 22 Nov 2017 23:00:00 -0000

ros-melodic-cartographer (0.2.0-0bionic) bionic; urgency=high

  https://github.com/googlecartographer/cartographer/compare/0.1.0...0.2.0

 -- The Cartographer Owners <cartographer-owners@googlegroups.com>  Sun, 18 Jun 2017 22:00:00 -0000

ros-melodic-cartographer (0.1.0-0bionic) bionic; urgency=high

  * First unstable development release

 -- The Cartographer Owners <cartographer-owners@googlegroups.com>  Wed, 17 May 2017 22:00:00 -0000
