=== debian/control ===
Source: ros-melodic-cartographer
Section: misc
Priority: extra
Maintainer: The Cartographer Authors <cartographer-owners@googlegroups.com>
Build-Depends: debhelper (>= 9.0.0), g++, google-mock, libboost-all-dev, libcairo2-dev, libceres-dev, libeigen3-dev, libgflags-dev, libgoogle-glog-dev, liblua5.2-dev, libprotobuf-dev, libprotoc-dev, protobuf-compiler, python-sphinx, ros-melodic-catkin
Homepage: https://github.com/googlecartographer/cartographer
Standards-Version: 3.9.2

Package: ros-melodic-cartographer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libcairo2-dev, libceres-dev, libeigen3-dev, libgflags-dev, libgoogle-glog-dev, liblua5.2-dev, libprotobuf-dev, libprotoc-dev, protobuf-compiler
Description: Cartographer is a system that provides real-time simultaneous localization and mapping (SLAM) in 2D and 3D across multiple platforms and sensor configurations.
